option default integer
#include "j_addr.inc"
mode 1,8

load bmp "jokes.bmp"' title screen

const paper=0,pen=1,cYellow=2,cOrange=3,cRed=4,cRose=5,cMagenta=6,cViolet=7
const cBlue=8,cAzure=9,cCyan=10,cAqua=11,cGreen=12,cLtGreen=13,cGrey=14,cDkGrey=15
const cMaroon=16,cDkBlue=17,cBlack2=18,cBlack=19,cWhite=20

dim wid=63' page character width -1
dim j_add' Joke addess for peeking
dim Joke_Num' joke number (order is randomised)
dim Jokes_Total' number of jokes - read form joke adress offset inc file
dim p' character peeked
dim pp$' string for building joke
dim i,j,x' general counters
dim n,r,g,b' throw away values for reading palette data
dim qa' flag for Q/A joke
dim xit' flag to exit a subroutine
' note: Joke_Addr(Jokes_Total) is dim'ed and read during joke load routine

JokeLoad' load jokes

Palette' set colours
 
font 2
colour map(pen),map(paper)
cls
box 0,0,799,23,,map(cBlack2),map(cBlack2)
box 0,577,799,22,,map(cBlack2),map(cBlack2)
text 360,0,"I S O L A T I O N    J O K E S",c,3,,map(cYellow),map(cBlack2)

box 0,23,799,554,,map(cGreen)
box 2,25,795,550,,map(cYellow)

text 400,40,"A collection of 948 humorous stories and one liners, some of",c
text 400,65,"which are sure to make you laugh or at least somewhat amuse",c
text 400,90,"you or maybe just make you smile or smirk a little.",c
text 400,115,"Unfortunately, it's more likely you will groan and",c
text 400,140,"wince and roll your eyes at the poor attempt at humour.",c
text 400,190,"Jokes and stories have been taken/borrowed/stolen from all",c
text 400,215,"over the internet and from friends and family.",c
text 400,265,"Quality is not guaranteed!",c
text 400,315,"All(?) jokes are kid friendly though some jokes need an",c
text 400,340,"adult mind to truly grasp.",c
text 400,390,"Apologies to blondes, the Irish and to all the other groups",c
text 400,415,"that have their stereotypes as a focus for some jokes.",c
text 400,465,"Order of jokes is randomised for each session.",c
text 400,515,"Press [SPACE] for the next joke or for the 2nd part of a joke.",c,,,map(cAqua)
text 400,540,"[Q] will quit at anytime, [0-9] will change colour scheme.",c,,,map(cAqua)

waitspace "Press [SPACE] start or [Q] to quit"
Joke_Num=1
do
  j_add=ld_add+Joke_Addr(Joke_Num)
  text 800,5,"Joke #"+str$(Joke_Num,3,0,"0"),r,1,,map(cWhite),map(cBlack2)
  joke_prnt
  waitspace "[SPACE] to continue [Q] to quit [0-9] for colours"
  inc Joke_Num
loop until Joke_Num>Jokes_Total
end

'print routine
sub joke_prnt

qa=0
box 4,30,791,544,,map(0),map(0)
print @(0,70);
pp$=""
xit=0
do'Peak_A_Boo:
p=peek(byte j_add)
inc j_add

select case p

case 182
  print @(mm.info(hpos)+20,)pp$
  xit=1
case 174
  answer
  p=32
case 169
  pp$="Q:"
  qa=1
  p=32
case 188
  print @(mm.info(hpos)+20,)pp$
  pp$=" "
  p=8
case 189
  print @(mm.info(hpos)+20,)pp$
  pp$=""
  p=10

end select

pp$=pp$+chr$(p)
if len(pp$)>wid then truncate:print @(mm.info(hpos)+20,)pp$:pp$=""

loop until xit=1

end sub

' It's a Q/A joke... pause for [SPACE] and add A: to answer

sub answer

  print @(mm.info(hpos)+20,)pp$
  waitspace "Press [SPACE] for Answer"
  pp$="A:"
  print @(0,300);

end sub

' fit text to screen width

sub truncate

  x=len(pp$)
    do
      inc x,-1
      inc j_add,-1
    loop until mid$(pp$,x,1)=" "
  pp$=left$(pp$,x)

end sub

' 1) poke joke file to screen page 1. 2) load offets for each joke. 3) randomise joke order

sub JokeLoad

  ld_add=mm.info(page address 1)
  f$="Jokes_all.dat"
  open f$ for input as #1
  x=0
  do while not eof(#1)
    bite=asc(input$(1,#1))
    poke byte ld_add+x,bite
    inc x
  loop
  close #1

' load joke addresses
restore Jokes_Count
read Jokes_Total 

dim Joke_Addr(Jokes_Total)

restore Jokes_Addr
for i=1 to Jokes_Total
  read Joke_Addr(i)
next i

' randomize joke order
for i=1 to Jokes_Total
  j=int(rnd*Jokes_Total)+1
  x=Joke_Addr(i)
  Joke_Addr(i)=Joke_Addr(j)
  joke_Addr(j)=x
next i

end sub

' flashing message at base of screen and wait for [SPACE]

sub waitspace m$

cc=1
do
k$=inkey$
if k$=" " then exit do
select case k$
  case "q", "Q"
    end
  case "0"
    map(0)=rgb(0,0,0)
    map(1)=rgb(255,255,255)
    map set
  case "1"
map reset:save image "jokes_Screen.bmp"
    'map(0)=rgb(255,255,255)
    'map(1)=rgb(0,0,0)
    'map set
  case "2"
    map(0)=rgb(0,0,75)
    map(1)=rgb(255,255,0)
    map set
  case "3"
    map(0)=rgb(75,75,75)
    map(1)=rgb(255,255,255)
    map set
  case "4"
    map(0)=rgb(50,50,50)
    map(1)=rgb(127,255,0)
    map set
  case "5"
    map(0)=rgb(100,0,0)
    map(1)=rgb(255,127,0)
    map set
  case "6"
    map(0)=rgb(127,75,0)
    map(1)=rgb(255,255,0)
    map set
  case "7"
    map(0)=rgb(0,75,75)
    map(1)=rgb(0,255,255)
    map set
  case "8"
    map(0)=rgb(0,75,0)
    map(1)=rgb(0,255,127)
    map set
  case "9"
    map(0)=rgb(75,0,75)
    map(1)=rgb(255,0,127)
    map set
end select

inc cc
pause 1
text 400,578,m$,c,3,,rgb(cc mod 256,0,0),map(cBlack2)
loop

text 400,578,space$(len(m$)),c,3,,,map(cBlack2)

end sub

' set up colours

sub Palette

restore c0
for i=0 to 20
  read n,r,g,b
  map(n)=rgb(r,g,b)
next i
map set

end sub
  
c0: data 0,0,0,0' black - paper
data 1,255,255,255' white - pen
data 2,255,255,0' yellow
data 3,255,127,0' orange
data 4,255,0,0' red
data 5,255,0,127' rose
data 6,255,0,255' magenta
data 7,127,0,255' violet
data 8,0,0,255' blue
data 9,0,127,255' azure
data 10,0,255,255' cyan
data 11,0,255,127' aquamarine
data 12,0,255,0' green
data 13,127,255,0' LtGreen
data 14,150,150,150' light grey
data 15,75,75,75' dark grey
data 16,100,0,0' Maroon
data 17,0,0,75' DkBlue
data 18,0,0,0'cBlack2
data 19,0,0,0'cBlack
data 20,255,255,255'cWhite
